package reseauRoutier;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.TreeSet;

import parcours.Chemin;
import parcours.GrapheSimple;
import parcours.ParcoursSimple;
import grapheX.Graphe;
import grapheX.Sommet;

/**
 * @author blay
 *
 *On fait le choix de masquer la prsence d'un graphe. 
 *On veut manipuler le rseau routier uniquement par des noms.
 */
public class ReseauRoutier {

	Graphe reseau  = new GrapheSimple();

	//Optimisation
	HashMap<String, PointRoute> pointRoutes = new HashMap<String, PointRoute>();

	/**
	 * @param nomPointRoute
	 * Dans un reseau routier il n'est pas possible d'avoir plusieurs Points route qui ont le mme nom.
	 */
	PointRoute addPointRoute(String nomPointRoute){
		if (! pointRoutes.containsKey(nomPointRoute)) {
			PointRoute p = new PointRoute(nomPointRoute);
			reseau.ajouterSommet(p);
			pointRoutes.put(nomPointRoute, p);
			return p;
		}
		return pointRoutes.get(nomPointRoute);
	}

	public PointRoute addPointRoute(String string, double latitude, double longitude) {
		PointRoute p = addPointRoute( string);
//		p.setLatitude(latitude);
//		p.setLongitude(longitude);
		return p;
	}

	public PointRoute getPointRoute(String nomPoint){
		//System.out.println("pointRoutes : " + pointRoutes);
		return pointRoutes.get(nomPoint);
	}





	void addArcRoutier(String pDepart, String pArrivee, String intitule, int distance){
		PointRoute depart = getPointRoute(pDepart);
		PointRoute arrivee = getPointRoute(pArrivee);
		System.out.println("Point connu "+ pDepart +": " + reseau.sommets().contains(depart) + depart);
		ArcRoutier<PointRoute> arc = new ArcRoutier<PointRoute>(depart, arrivee,distance, intitule); 
		reseau.ajouterArc(arc);
	}

	HashMap<Sommet, Integer> getNextPointRoute(String p ){
		return reseau.Dijkstra2(getPointRoute(p));
	}

	@Override
	public String toString() {
		return "ReseauRoutier [" + reseau + "\n pointRoutes="
				+ pointRoutes + "]";
	}


	//Pas forcement dans cette classe
	//Attention a bien dfinir le compareTO dans Chemin
	public TreeSet<Chemin> cheminsDeA(String pDepart, String pArrivee){
		PointRoute depart = getPointRoute(pDepart);
		PointRoute arrivee = getPointRoute(pArrivee);
		ParcoursSimple ps = new ParcoursSimple(reseau);
		ArrayList<Chemin> chemins = ps.chemins(depart);
		TreeSet<Chemin> cheminsResultat = new TreeSet<Chemin>();
		for (Chemin c : chemins) {
			if (c.atteint(arrivee)) {
				Chemin res = c.extraireChemin(depart,arrivee);
				cheminsResultat.add(res);
			}
		}
		return cheminsResultat;
	}



}
